Unit Unit1;

{$MODE objfpc}{$H+}

Interface

Uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls,
  uDoNotTouchMe, uExtended_Dont_Touch;

Type

  { TForm1 }

  TForm1 = Class(TForm)
    Button1: TButton;
    Button2: TButton;
    ListBox1: TListBox;
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
  private
    MyVehicles: Array Of TVehicle; //
    Procedure UpdateMyVehicles;
  public

  End;

Var
  Form1: TForm1;

Implementation

{$R *.lfm}

{ TForm1 }

Procedure TForm1.FormCreate(Sender: TObject);
Begin
  MyVehicles := Nil;
End;

Procedure TForm1.UpdateMyVehicles;
Var
  i: Integer;
Begin
  ListBox1.items.BeginUpdate;
  ListBox1.Clear;
  For i := 0 To high(MyVehicles) Do Begin
    ListBox1.Items.add(MyVehicles[i].NewFeature);
  End;
  ListBox1.items.EndUpdate;
End;

Procedure TForm1.Button1Click(Sender: TObject);
Begin
  // Buy Car
  setlength(MyVehicles, high(MyVehicles) + 2);
  MyVehicles[high(MyVehicles)] := TCar.Create();
  UpdateMyVehicles;
End;

Procedure TForm1.Button2Click(Sender: TObject);
Begin
  // Buy Plane
  setlength(MyVehicles, high(MyVehicles) + 2);
  MyVehicles[high(MyVehicles)] := TPlane.Create();
  UpdateMyVehicles;
End;

End.

